Create or update a file
curl --request PUT \
--url https://api.hubapi.com/cms/v3/source-code/{environment}/content/{path} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: multipart/form-data' \
--form file='@example-file'import requests
url = "https://api.hubapi.com/cms/v3/source-code/{environment}/content/{path}"
files = { "file": ("example-file", open("example-file", "rb")) }
headers = {"Authorization": "Bearer <token>"}
response = requests.put(url, files=files, headers=headers)
print(response.text)const form = new FormData();
form.append('file', '<string>');
const options = {method: 'PUT', headers: {Authorization: 'Bearer <token>'}};
options.body = form;
fetch('https://api.hubapi.com/cms/v3/source-code/{environment}/content/{path}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"createdAt": 123,
"folder": true,
"id": "<string>",
"name": "<string>",
"updatedAt": 123,
"archivedAt": 123,
"children": [
"<string>"
],
"hash": "<string>"
}{
"message": "Invalid input (details will vary based on the error)",
"correlationId": "aeb5f871-7f07-4993-9211-075dc63e7cbf",
"category": "VALIDATION_ERROR",
"links": {
"knowledge-base": "https://www.hubspot.com/products/service/knowledge-base"
}
}Source code
Create or update a file
Upserts a file at the specified path in the specified environment. Accepts multipart/form-data content type.
PUT
/
cms
/
v3
/
source-code
/
{environment}
/
content
/
{path}
Create or update a file
Supported products
Supported products
Required Scopes
Required Scopes
Authorizations
The access token received from the authorization server in the OAuth 2.0 flow.
Body
multipart/form-data
Response
successful operation
Timestamp of when the object was first created.
Determines whether or not this path points to a folder.
The path of the file in the CMS Developer File System.
The name of the file.
Timestamp of when the object was last updated.
Timestamp of when the object was archived (deleted).
If the object is a folder, contains the filenames of the files within the folder.
A unique identifier for the file's content, used to verify data integrity.
Last modified on March 30, 2026
Was this page helpful?
⌘I